<?php
/*
This file is part of ShopChart.

ShopChart is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ShopChart is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ShopChart.  If not, see <http://www.gnu.org/licenses/>.
*/

require_once('mysqli.php');

function add_assembly_type_assembly($assembly_type_id, $assembly_id) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    $mysqli->query("
INSERT IGNORE INTO AssemblyTypeItems (
    atiAssemblyTypeID,
    atiItemID,
    atiQuantity
) SELECT
    $assembly_type_id,
    atiItemID,
    SUM(atiQuantity)
FROM
    (SELECT
        atiItemID,
        atiQuantity
    FROM
        Assemblies INNER JOIN
            AssemblyTypeItems
        ON aAssemblyTypeID = atiAssemblyTypeID
    WHERE
        aAssemblyID = $assembly_id
    UNION
    SELECT
        tlItemID,
        tlQuantity
    FROM
        TransactionLines INNER JOIN (
            Transactions INNER JOIN
                TransactionTypes
            ON tTransactionTypeID = ttTransactionTypeID
        ) ON tlTransactionID = tTransactionID
    WHERE
        tlAssemblyID = $assembly_id
    ) ati
GROUP BY
    atiItemID");
}

function add_assembly_type($description) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    $mysqli->query("
INSERT INTO AssemblyTypes (
    atDescription
) VALUES (
    '" . $mysqli->real_escape_string($description) . "'
)");
    $assembly_type_id = $mysqli->insert_id;
    if($assembly_type_id == 0) {
        $assembly_type_id = $mysqli->query("
SELECT
    atAssemblyTypeID
FROM
    AssemblyTypes
WHERE
    atDescription = '" . $mysqli->real_escape_string($description) . "'");
        if($assembly_type_id = $assembly_type_id->fetch_assoc()) {
            return $assembly_type_id['atAssemblyTypeID'];
        } else {
            return 0;
        }
    } else {
        return $assembly_type_id;
    }
}

function add_assembly_type_item($assembly_type_id, $item_id) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    $mysqli->query("
INSERT IGNORE INTO AssemblyTypeItems (
    atiAssemblyTypeID,
    atiItemID,
    atiQuantity
) VALUES (
    $assembly_type_id,
    $item_id,
    1
)");
}

function get_assembly_type_attributes($attributes) {
    global $mysqli;
    $set = '';
    if(isset($attributes['p_atDescription']) && $attributes['p_atDescription'] <> $attributes['atDescription']) {
        $set .= "
    atDescription = '" . $mysqli->real_escape_string($attributes['atDescription']) . "',";
    }
}

function get_assembly_type_item_attributes($attributes) {
    global $mysqli;
    $set = '';
    if(isset($attributes['p_atiQuantity']) && $attributes['p_atiQuantity'] <> $attributes['atiQuantity']) {
        if($attributes['atiQuantity'] < 1) {
            $set = "DELETE";
        } else {
            $set .= "
    atiQuantity = " . $mysqli->real_escape_string($attributes['atiQuantity']) . ",";
        }
    }
    return $set;
}

function update_attributes($assembly_type_id, $item_id, $attributes) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    $set = get_assembly_type_attributes($attributes);
    if($set <> '') {
        $mysqli->query("
UPDATE
    AssemblyTypes
SET" . substr($set, 0, strlen($set) - 1) . "
WHERE
    atAssemblyTypeID = $assembly_type_id");
    }
    $set = get_assembly_type_item_attributes($attributes);
    if($set <> '') {
        if($set == 'DELETE') {
            $mysqli->query("
DELETE
FROM
    AssemblyTypeItems
WHERE
    atiAssemblyTypeID = $assembly_type_id
    AND atiItemID = $item_id");
        } else {
            $mysqli->query("
UPDATE
    AssemblyTypeItems
SET" . substr($set, 0, strlen($set) - 1) . "
WHERE
    atiAssemblyTypeID = $assembly_type_id
    AND atiItemID = $item_id");
        }
    }
}

function get_assembly_types($filter) {
    global $mysqli;
    if($filter <> '') {
        $filter = "WHERE
    atDescription LIKE '%" . $mysqli->real_escape_string($filter) . "%'";
    }
    return $mysqli->query("
SELECT
    atAssemblyTypeID,
    atDescription
FROM
    AssemblyTypes
$filter
ORDER BY
    atDescription");
}

function get_assembly_type_items($assembly_type_id, $filter) {
    global $mysqli;
    if($filter == '' || $filter == 'Any Description') {
        $filter = '';
    } else {
        $filter = "AND iDescription LIKE '%" . $mysqli->real_escape_string($filter) . "%'";
    }
    return $mysqli->query("
SELECT
    atiItemID,
    iDescription,
    atiQuantity
FROM
    Items INNER JOIN
        AssemblyTypeItems
    ON iItemID = atiItemID
WHERE
    atiAssemblyTypeID = $assembly_type_id
    $filter
ORDER BY
    iDescription");
}