<?php
/*
This file is part of ShopChart.

ShopChart is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ShopChart is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ShopChart.  If not, see <http://www.gnu.org/licenses/>.
*/

require_once('fun/mysqli.php');

function add_person($first_name, $last_name) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    $mysqli->query("
INSERT INTO People (
    pFirstName,
    pLastName
) VALUES (
    '" . $mysqli->real_escape_string($first_name) . "',
    '" . $mysqli->real_escape_string($last_name) . "'
)");
    return $mysqli->insert_id;
}

function delete_person($person_id, $new_from_person_id, $new_to_person_id) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    print("
UPDATE
    Transactions
SET
    tFromPersonID = $new_from_person_id
WHERE
    tFromPersonID = $person_id");
//    $mysqli->query("
    print("
UPDATE
    Transactions
SET
    tToPersonID = $new_to_person_id
WHERE
    tToPersonID = $person_id");
//    $mysqli->query("
    print("
DELETE
FROM
    People
WHERE
    pPersonID = $person_id");
}

function get_person_attributes($attributes) {
    global $mysqli;
    $set = '';
    if(isset($attributes['p_pFirstName'])) {
        if($attributes['p_pFirstName'] <> $attributes['pFirstName']) {
            $full_name = $mysqli->real_escape_string($attributes['pFirstName']);
            $set .= "
    pFirstName = '" . $full_name . "',";
        } else {
            $full_name = $attributes['p_pFirstName'];
        }
    } else {
        $full_name = '';
    }
    if(isset($attributes['p_pLastName'])) {
        if($attributes['p_pLastName'] <> $attributes['pLastName']) {
            $last_name = $mysqli->real_escape_string($attributes['pLastName']);
            $full_name .= $last_name;
            $set .= "
    pLastName = '" . $last_name . "',";
        } else {
            $full_name .= $attributes['p_pLastName'];
        }
    }
    if($full_name == '') {
        throw new Exception("The first name and last name cannot both be left blank.");
    }
    if(isset($attributes['p_pMonetaryPerSecond']) && $attributes['p_pMonetaryPerSecond'] <>
        $attributes['pMonetaryPerSecond']) {
        if(!is_numeric($attributes['pMonetaryPerSecond'])) {
            throw new Exception("The hourly rate must be a numeric value.");
        }
        if($attributes['pMonetaryPerSecond'] == 0) {
            $set .= "
    pMonetaryPerSecond = 0,";
        } else {
            $set .= "
    pMonetaryPerSecond = " . ($attributes['pMonetaryPerSecond'] / 3600) . ",";
        }
    }
    if(isset($attributes['p_pPublic']) <> isset($attributes['pPublic'])) {
        if(isset($attributes['pPublic'])) {
            $set .= "
    pFlags = pFlags | " . PF_PUBLIC . ",";
        } else {
            $set .= "
    pFlags = pFlags ^ " . PF_PUBLIC . ",";
        }
    }
    return $set;
}

function update_attributes($person_id, $attributes) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    $set = get_person_attributes($attributes);
    if($set <> '') {
        $mysqli->query("
UPDATE
    People
SET " . substr($set, 0, strlen($set) - 1) . "
WHERE
    pPersonID = $person_id");
    }
//    if(isset($attributes['plPrimary'])) {
//        $mysqli->query("
//UPDATE
//    PersonLocations
//SET
//    plPrimary = plLocationID = " . $attributes['plPrimary'] . "
//WHERE
//    plPersonID = $person_id");
//    }
}

function get_people($first_name, $last_name) {
    global $mysqli;
    if($first_name == '') {
        $where = "";
    } else {
        $where = "    pFirstName LIKE '%" . $mysqli->real_escape_string($first_name) . "%'";
    }
    if($last_name <> '') {
        $where .= " OR pLastName LIKE '%" . $mysqli->real_escape_string($last_name) . "%'";
    }
    if($where <> '') {
        $where = "WHERE " . substr($where, 3);
    }
    return $mysqli->query("
SELECT
    pPersonID,
    pFirstName,
    pLastName,
    COALESCE(pMonetaryPerSecond, 0) pMonetaryPerSecond,
    pFlags
FROM
    People
$where");
}

//function get_person_locations($person_id) {
//    global $mysqli;
//    return $mysqli->query("
//SELECT
//    plLocationID,
//    plPrimary,
//    lStreet,
//    lStreet2,
//    lCity,
//    lState,
//    lPostalCode
//FROM
//    Locations INNER JOIN
//        PersonLocations
//    ON lLocationID = plLocationID
//WHERE
//    plPersonID = $person_id
//ORDER BY
//    lStreet");
//}
//
//function add_person_location($person_id, $location_id) {
//    if(!isset($GLOBALS['administrator'])) return;
//    global $mysqli;
//    $mysqli->query("
//INSERT IGNORE INTO PersonLocations (
//    plPersonID,
//    plLocationID,
//    plPrimary
//) VALUES (
//    $person_id,
//    $location_id,
//    1
//)");
//}