<?php
/*
This file is part of ShopChart.

ShopChart is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ShopChart is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ShopChart.  If not, see <http://www.gnu.org/licenses/>.
*/
     
require_once('fun/mysqli.php');

function add_transaction_type($description, $inventory_modifier) {
    if(!isset($GLOBALS['administrator'])) return;
    global $mysqli;
    $description = $mysqli->real_escape_string($description);
    if($description == '') {
        throw new Exception("The Transaction Type's Description cannot be left blank.");
    }
    $mysqli->query("
INSERT INTO TransactionTypes (
    ttDescription,
    ttFlags
) VALUES (
    '" . $mysqli->real_escape_string($description) . "',
    " . $inventory_modifier . "
)");
    $transaction_type_id = $mysqli->insert_id;
    if($transaction_type_id == 0) {
        $transaction_type_id = $mysqli->query("
SELECT
    ttTransactionTypeID
FROM
    TransactionTypes
WHERE
    tDescription = '" . $mysqli->real_escape_string($description) . "'");
        if($transaction_type_id = $transaction_type_id->fetch_assoc()) {
            return $transaction_type_id['ttTransactionTypeID'];
        } else {
            return 0;
        }
    } else {
        return $transaction_type_id;
    }
}

function get_transaction_type_attributes($attributes) {
    global $mysqli;
    $set = '';
    if(isset($attributes['p_ttDescription']) && $attributes['p_ttDescription'] <> $attributes['ttDescription']) {
        $description = $mysqli->real_escape_string($attributes['ttDescription']);
        if($description == '') {
            throw new Exception("The Transaction Type's Description cannot be left blank.");
        }
        $set .= "
    ttDescription = '" . $description . "',";
    }
    if(isset($attributes['p_ttFlags']) && $attributes['p_ttFlags'] <> ((int)$attributes['ttInventoryModifier'] |
        (int)$attributes['ttAmountType'])) {
        $set .= "
    ttFlags = " . ((int)$attributes['ttInventoryModifier'] | (int)$attributes['ttAmountType']) . ",";
    }
    return $set;
}

function update_attributes($transaction_type_id, $attributes) {
    if(!isset($GLOBALS['administrator'])) return;
    $set = get_transaction_type_attributes($attributes);
    if($set <> '') {
        global $mysqli;
        $mysqli->query("
UPDATE
    TransactionTypes
SET" . substr($set, 0, strlen($set) - 1) . "
WHERE
    ttTransactionTypeID = $transaction_type_id");
    }
}

function get_transaction_types($filter = '') {
    global $mysqli;
    return $mysqli->query("
SELECT
    ttTransactionTypeID,
    ttDescription,
    ttFlags
FROM
    TransactionTypes
" . ($filter == '' ? "" : "WHERE
    ttDescription LIKE '%" . $mysqli->real_escape_string($filter) . "%'
") . "ORDER BY
    ttDescription");
}