<?php
/*
This file is part of ShopChart.

ShopChart is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ShopChart is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ShopChart.  If not, see <http://www.gnu.org/licenses/>.
*/

require_once 'fun/common.php';
require_once 'fun/items.php';
define("ITEM_PAGE_SIZE", 27);
$keys = get_settings(array(
    'item_id' => 0));
$settings = get_settings(array(
    'description_filter' => '',
    'transaction_type_filter' => 0,
    'p_page_number' => 1,
    'page_number' => 1,
    'models' => null,
    'sender' => null,
    'item_sort' => ''));
if(isset($_SERVER['HTTP_REFERER'])) {
    $referer = parse_url($_SERVER['HTTP_REFERER']);
    if($referer['path'] == '/ShopChart/items.php') {
        $settings['page_number'] = get_page_number('page_number', 'previous_page', 'next_page');
        if(isset($_POST['add_item'])) {
            $keys['item_id'] = add_item($_POST['new_description']);
        } elseif(isset($_POST['add_assembly'])) {
            header('Location: ' . htmlspecialchars(str_replace('%26', '&', $settings['sender'])) . 
                '&assembly_id=' . $_POST['assembly_id']);
        } else {
            if($_SERVER['REQUEST_METHOD'] == 'POST') {
                update_attributes($keys['item_id'], $_POST);
            }
        }
    }
}
$items = get_items($settings['description_filter'], $settings['user'], $settings, $settings['item_sort']);
$max_pages = get_max_pages($items, ITEM_PAGE_SIZE);
$settings['page_number'] = go_to_page($keys['item_id'], 'iItemID', $items, ITEM_PAGE_SIZE,
    $settings['page_number'], $max_pages, ($settings['p_page_number'] == $settings['page_number']));
$displayed = 0;
print '
<!DOCTYPE html>
<html>
    <head>
        <style type="text/css">
            @import url(css/shop_chart.css);
            @import url(css/items.css);
        </style>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Items</title>
    </head>
    <body>
        <form action="items.php" method="post">';
include 'top_nav.php';
if(isset($settings['models'])) {
    print '
            <div class="special_criteria">Only showing Items for which SketchUp models have been made.
                <a href="items.php?item_id=' . $keys['item_id'] . get_params(remove_settings($settings, 'models'),
        false) . '">Remove</a></div>';
}
print '
            <div id="left_side">
                <table id="items">';
if($max_pages > 1) {
    print '
                    <tr class="page_nav">
                        <td colspan="4">
                            <input type="submit" name="previous_page" value="Previous" />
                            <input type="text" name="page_number" value="' . $settings['page_number'] . '" /> of ' .
    $max_pages . '
                            <input type="submit" name="next_page" value="Next" />
                        </td>
                    </tr>';
}
$resort_params = get_params(remove_settings($settings, 'item_sort'), false);
$new_item_sort = array(
    1 => change_sort_field($settings['item_sort'], 1),
    2 => change_sort_field($settings['item_sort'], 2),
    3 => change_sort_field($settings['item_sort'], 3),
    4 => change_sort_field($settings['item_sort'], 4)
);
print '
                    <tr class="field_header">
                        <th><a href="items.php?item_sort=' . $new_item_sort[1] . $resort_params . '">Description</a></th>
                        <th><a href="items.php?item_sort=' . $new_item_sort[2] . $resort_params . '">Qty</a></th>
                        <th><a href="items.php?item_sort=' . $new_item_sort[3] . $resort_params . '">Qty On</a></th>
                        <th><a href="items.php?item_sort=' . $new_item_sort[4] . $resort_params . '">Qty To</a></th>
                    </tr>
                    <tr class="field_header">
                        <th><input type="text" name="description_filter" value="' .
    htmlspecialchars($settings['description_filter']) . '" /></th>
                `       <th><a href="items.php?item_sort=' . $new_item_sort[2] . $resort_params . '">Needed</a></th>
                        <th><a href="items.php?item_sort=' . $new_item_sort[3] . $resort_params . '">Hand</a></th>
                        <th><a href="items.php?item_sort=' . $new_item_sort[4] . $resort_params . '">Order</a></th>
                    </tr>';
while ($item = $items->fetch_assoc()) {
    if (!isset($selected_item) && !isset($settings['sender']) && ($item['iItemID'] == $keys['item_id'] ||
        $keys['item_id'] == 0)) {
        $keys['item_id'] = $item['iItemID'];
        $selected_item = $item;
        print '
                    <tr class="selected_row">
                        <td class="description">
                            <input type="submit" class="delete" name="delete_item" value=" " />
                            <input type="text" name="iDescription" value="' .
            htmlspecialchars($item['iDescription']) . '" />
                        </td>';
        if($item['iQuantityNeeded'] > 0 && !isset($settings['sender'])) {
            print '
                        <td class="quantity"><a href="assemblies.php?iqn_item_id=' . $item['iItemID'] . '">' .
                $item['iQuantityNeeded'] . '</a></td>';
        } else {
            print '
                        <td class="quantity">' . $item['iQuantityNeeded'] . '</td>';
        }
        if($item['iHasHistory'] > 0 && !isset($settings['sender'])) {
            print '
                        <td class="quantity"><a href="transactions.php?qoh_item_id=' . $item['iItemID'] . '">' .
                $item['iQuantityOnHand'] . '</a></td>';
        } else {
            print '
                        <td class="quantity">' . $item['iQuantityOnHand'] . '</td>';
        }
        print '
                        <td class="quantity">' . $item['iQuantityToOrder'] . '</td>
                    </tr>';
    } else {
        if($displayed % 2) {
            print '
                    <tr class="odd_row">';
        } else {
            print '
                    <tr class="even_row">';
        }
        if(isset($settings['sender'])) {
            print '
                        <td class="description"><a href="' . htmlspecialchars(str_replace('%26', '&',
                $settings['sender'])) . '&item_id=' . $item['iItemID'] . '">' .
                htmlspecialchars($item['iDescription']) . '</a></td>';
        } else {
            print '
                        <td class="description"><a href="items.php?item_id=' . $item['iItemID'] .
                get_params($settings, false) . '">' . htmlspecialchars($item['iDescription']) . '</a></td>';
        }
        if($item['iQuantityNeeded'] > 0 && !isset($settings['sender'])) {
            print '
                        <td class="quantity"><a href="assemblies.php?iqn_item_id=' . $item['iItemID'] . '">' .
                $item['iQuantityNeeded'] . '</a></td>';
        } else {
            print '
                        <td class="quantity">' . $item['iQuantityNeeded'] . '</td>';
        }
        if($item['iHasHistory'] > 0 && !isset($settings['sender'])) {
            print '
                        <td class="quantity"><a href="transactions.php?qoh_item_id=' . $item['iItemID'] . '">' .
                $item['iQuantityOnHand'] . '</a></td>';
        } else {
            print '
                        <td class="quantity">' . $item['iQuantityOnHand'] . '</td>';
        }
        print '
                        <td class="quantity">' . $item['iQuantityToOrder'] . '</td>
                    </tr>';
    }
    if(++$displayed >= ITEM_PAGE_SIZE) {
        break;
    }
}
if(isset($settings['sender'])) {
    print '
                    <tr>
                        <td class="serial_number">
                            <select name="assembly_id">';
    foreach(get_assemblies() as $assembly_id => $serial_number) {
        print '
                                <option value="' . $assembly_id . '">' . htmlspecialchars($serial_number) .
            '</option>';
    }
    print '
                            </select>
                        <td>
                        </td>
                        <td>
                            <input type="submit" name="add_assembly" value="Add Assembly" />
                        </td>
                    </tr>
                </table>
                <input type="hidden" name="sender" value="' . str_replace('&', '%26', $settings['sender']) . '" />';
} else {
    print '
                    <tr class="footer">
                        <td>
                            <input type="text" name="new_description" />
                        </td>
                        <td>
                        </td>
                        <td>
                        </td>
                        <td>
                            <input type="submit" name="add_item" value="Add Item" />
                        </td>
                    </tr>
                </table>
            </div>
            <div id="right_side">
                <table id="suppliers">
                    <caption>Item Suppliers</caption>';
    if(isset($selected_item)) {
        $transaction_types = get_transaction_types();
        $transfers = get_transfer_info($keys['item_id'], $settings['user'], $settings['transaction_type_filter']);
        print '     <tr class="field_header">
                        <th>Type</th>
                        <th>Supplier</th>
                        <th>Last</th>
                    </tr>
                    <tr class="field_header">
                        <th class="transaction_type"><select name="transaction_type_filter" onchange="this.form.submit();">
                            <option value="0"></option>';
        foreach($transaction_types as $transaction_type_id => $description) {
            print '
                            <option value="' . $transaction_type_id . '"' . ($transaction_type_id == 
                $settings['transaction_type_filter'] ? ' selected="true"' : '') . '>' .
                htmlspecialchars($description) . '</option>';
        }
        print '
                        </select></th>
                        <th></th>
                        <th>Cost</th>
                    </tr>';
        $displayed = 0;
        while($info = $transfers->fetch_assoc()) {
            if($displayed++ % 2) {
                print '
                    <tr class="odd_row">';
            } else {
                print '
                    <tr class="even_row">';
            }
            print '
                        <td class="transaction_type"><a href="transactions.php?transaction_id=' .
                $info['htcTransactionID'] . '">' . $transaction_types[$info['htcTransactionTypeID']] . '</a></td>
                        <td class="person">' . htmlspecialchars($info['htcFromPersonName']) . '</td>
                        <td class="money">';
            if($info['htcFromURL'] <> '') {
                print '<a href="' . htmlspecialchars($info['htcFromURL']) . ' target="_blank">' .
                    money_format('%.2n', $info['tlUnitAmount']) . '</a></td>';
            } else {
                print money_format('%.2n', $info['tlUnitAmount']) . '</td>';
            }
            print '
                    </tr>';
        }
    } else {
        print '
                            <select disabled="true"></select>
                        </th>
                    </tr>
                    <tr class="field_header">
                        <th>Type</th>
                        <th>Supplier</th>
                        <th>Last</th>
                    </tr>
                    <tr class="field_header">
                        <th><select disabled="true"></select></th>
                        <th></th>
                        <th>Cost</th>
                    </tr>';
    }
    print '
                </table>
                <div id="item_image">';
    if(isset($selected_item)) {
        if($selected_item['iImageURL'] <> '') {
            if($selected_item['iImageLink'] <> '') {
                print '
                    <a href="' . htmlspecialchars($selected_item['iImageLink']) . '">
                        <img src="' . htmlspecialchars($selected_item['iImageURL']) . '" />
                    </a>';
            } else {
                print '
                    <img src="' . htmlspecialchars($selected_item['iImageURL']) . '" />';
            }
        }
        print '
                    <br />
                    <label>Image URL</label><input type="text" name="iImageURL" value="' .
            htmlspecialchars($selected_item['iImageURL']) . '" /><br />
                    <label>Image Link</label><input type="text" name="iImageLink" value="' .
            htmlspecialchars($selected_item['iImageLink']) . '" /><br />
                    <label>Weight</label><input type="text" name="iWeight" value="' .
            htmlspecialchars($selected_item['iWeight']) . '" />
                </div>
                <div id="information">
                    <textarea name="iInformation">' . htmlspecialchars($selected_item['iInformation']) .
            '</textarea>
                </div>
                <input type="hidden" name="p_page_number" value="' . $settings['page_number'] . '" />
                <input type="hidden" name="item_id" value="' . $keys['item_id'] . '" />
                <input type="hidden" name="p_iDescription" value="' .
            htmlspecialchars($selected_item['iDescription']) . '" />
                <input type="hidden" name="p_iImageURL" value="' . htmlspecialchars($selected_item['iImageURL']) .
            '" />
                <input type="hidden" name="p_iImageLink" value="' . htmlspecialchars($selected_item['iImageLink']) .
            '" />
                <input type="hidden" name="p_iWeight" value="' . htmlspecialchars($selected_item['iWeight']) .
            '" />
                <input type="hidden" name="p_iInformation" value="' .
            htmlspecialchars($selected_item['iInformation']) . '" />';
    } else {
        print '
                    <label>Image URL</label><input type="text" disabled="true" /><br />
                    <label>Image Link</label><input type="text" disabled="true" />
                </div>
                <div id="information">
                    <textarea disabled="true"></textarea>
                </div>';
    }
}
print '
            </div>';
if(isset($settings['models'])) {
    print '
            <input type="hidden" name="models" value="' . $settings['models'] . '" />';
}
print '
        </form>
    </body>
</html>';

