<?php
/*
This file is part of ShopChart.

ShopChart is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ShopChart is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ShopChart.  If not, see <http://www.gnu.org/licenses/>.
*/

if(isset($_SERVER['REQUEST_URI'])) {
    $current_page = parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);
} else {
    $current_page = 'none';
}
if(!isset($help_link)) {
    $help_link = 'doc/index.xhtml';
}
print '
            <div id="header">
                <div id="masthead">
                    <a href="http://www.shadetreekeys.com">
                        <img src="img/masthead.png" alt="Shadetree Keys" />
                    </a>
                </div>
                <div id="top_nav">
                    <nav>';
if($current_page == '/ShopChart/assemblies.php') {
    print '
                        <div id="selected_nav_link">
                            <a href="assemblies.php">Assemblies</a>
                        </div>';
    $help_link = 'doc/assemblies.xhtml';
} else {
    print '         
                        <div class="nav_link">
                            <a href="assemblies.php">Assemblies</a>
                        </div>';
}
if($current_page == '/ShopChart/items.php') {
    print '
                        <div id="selected_nav_link">
                            <a href="items.php">Items</a>
                        </div>';
    $help_link = 'doc/items.xhtml';
} else {
    print '
                        <div class="nav_link">
                            <a href="items.php">Items</a>
                        </div>';
}
if($current_page == '/ShopChart/people.php') {
    print '
                        <div id="selected_nav_link">
                            <a href="people.php">People</a>
                        </div>';
    $help_link = 'doc/people.xhtml';
} else {
    print '
                        <div class="nav_link">
                            <a href="people.php">People</a>
                        </div>';
}
if($current_page == '/ShopChart/transactions.php') {
    print '
                        <div id="selected_nav_link">
                            <a href="transactions.php">Transactions</a>
                        </div>';
    $help_link = 'doc/transactions.xhtml';
} else {
    print '
                        <div class="nav_link">
                            <a href="transactions.php">Transactions</a>
                        </div>';
}
if(isset($nav_links)) {
    print $nav_links;
}
print '
                    </nav>
                </div>
                <div id="save_changes">
                    <input type="submit" name="commit" value="Save Changes" />
                </div>
                <div id="help_link">
                    <a href="' . $help_link . '">Help</a>
                </div>
                <div id="masthead_underline">
                    <img src="img/masthead_w.png" />
                </div>
            </div>';
if(isset($error)) {
    print '
            <div id="error">' . $error . '</div>';
}