delimiter $$

CREATE DATABASE `ShopChart` /*!40100 DEFAULT CHARACTER SET latin1 */$$

USE `ShopChart`$$

CREATE TABLE `Assemblies` (
  `aAssemblyID` int(11) NOT NULL AUTO_INCREMENT,
  `aAssemblyTypeID` int(11) NOT NULL DEFAULT '0',
  `aFlags` int(11) DEFAULT NULL,
  `aImageLink` text,
  `aImageURL` text,
  `aSerialNumber` varchar(255) NOT NULL,
  PRIMARY KEY (`aAssemblyID`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1$$


CREATE TABLE `AssemblyTypeItems` (
  `atiAssemblyTypeID` int(11) NOT NULL,
  `atiItemID` int(11) NOT NULL,
  `atiQuantity` decimal(11,2) NOT NULL,
  PRIMARY KEY (`atiAssemblyTypeID`,`atiItemID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1$$


CREATE TABLE `AssemblyTypes` (
  `atAssemblyTypeID` int(11) NOT NULL AUTO_INCREMENT,
  `atDescription` varchar(255) NOT NULL,
  PRIMARY KEY (`atAssemblyTypeID`),
  UNIQUE KEY `atDescription_UNIQUE` (`atDescription`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1$$


CREATE TABLE `Items` (
  `iDescription` varchar(255) NOT NULL,
  `iInformation` text,
  `iImageLink` text,
  `iImageURL` text,
  `iItemID` int(11) NOT NULL AUTO_INCREMENT,
  `iWeight` decimal(9,4) DEFAULT NULL,
  PRIMARY KEY (`iItemID`),
  UNIQUE KEY `iDescription_UNIQUE` (`iDescription`)
) ENGINE=InnoDB AUTO_INCREMENT=454 DEFAULT CHARSET=latin1$$


CREATE TABLE `People` (
  `pFirstName` varchar(255) DEFAULT NULL,
  `pFlags` int(11) NOT NULL DEFAULT '0',
  `pLastName` varchar(255) DEFAULT NULL,
  `pMonetaryPerSecond` decimal(9,7) DEFAULT NULL,
  `pPersonID` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`pPersonID`)
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=latin1$$


CREATE TABLE `PersonGroups` (
  `pgGroupID` int(11) NOT NULL,
  `pgPersonID` int(11) NOT NULL,
  `pgPrimary` bit(1) NOT NULL,
  PRIMARY KEY (`pgGroupID`,`pgPersonID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1$$


CREATE TABLE `Settings` (
  `setName` varchar(255) NOT NULL,
  `setValue` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`setName`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1$$


CREATE TABLE `TransactionLineGroups` (
  `tlgLineGroupID` int(11) NOT NULL,
  `tlgTotalAmount` decimal(11,2) NOT NULL,
  `tlgTransactionID` int(11) NOT NULL,
  PRIMARY KEY (`tlgLineGroupID`,`tlgTransactionID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1$$


CREATE TABLE `TransactionLines` (
  `tlAssemblyID` int(11) DEFAULT NULL,
  `tlFromURL` text,
  `tlItemID` int(11) NOT NULL,
  `tlLineGroupID` int(11) DEFAULT NULL,
  `tlLineID` int(11) NOT NULL DEFAULT '0',
  `tlQuantity` decimal(11,2) NOT NULL,
  `tlTransactionID` int(11) NOT NULL,
  `tlUnitAmount` decimal(9,4) DEFAULT NULL,
  PRIMARY KEY (`tlLineID`,`tlTransactionID`),
  KEY `tliItemID` (`tlItemID`,`tlTransactionID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1$$


CREATE TABLE `Transactions` (
  `tDate` datetime NOT NULL,
  `tFromPersonID` int(11) NOT NULL,
  `tShipping` decimal(11,2) NOT NULL DEFAULT '0.00',
  `tTax` decimal(11,3) NOT NULL DEFAULT '0.000',
  `tToPersonID` int(11) NOT NULL,
  `tTransactionID` int(11) NOT NULL AUTO_INCREMENT,
  `tTransactionTypeID` int(11) NOT NULL,
  PRIMARY KEY (`tTransactionID`)
) ENGINE=InnoDB AUTO_INCREMENT=290 DEFAULT CHARSET=latin1$$


CREATE TABLE `TransactionTypes` (
  `ttDescription` varchar(255) NOT NULL,
  `ttFlags` int(11) NOT NULL DEFAULT '0',
  `ttTransactionTypeID` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`ttTransactionTypeID`),
  UNIQUE KEY `ttDescription_UNIQUE` (`ttDescription`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1$$


